// +--------------------------------------------+
// |                                            |
// | ComxStart 1.0                              |
// |                                            |
// |    Module removed start of tasks           |
// |                                            |
// |                                            |
// | Copyright (C) 2006 Gawrilov Roman          |
// | e-mail: romik@xStarter.com                 |
// |                                            |
// |                                            |
// |                                            |
// |                                            |
// | Last updated: 23 July, 2006                |
// |                                            |
// +--------------------------------------------+

unit ComxStart;

interface

var xStarter: Variant;

  function CreatexStart: Boolean;

  procedure UnassignedxStart;


  
  {    }
  function GetSectionsCount: Integer;

  {      }
  function GetTasksCount(Section: Integer): Integer;

  {        }
  function RunTask (SectionNumber, TaskNumber: Integer): Boolean; overload;

  {          }
  function RunTask (SectionName, TaskName: String): Boolean; overload;

  {   . "Separator" -    }
  function GetListSection (Separator: String): String;

  {      . "Separator" -     }
  function GetListTasks (NameSection, Separator: String): String; overload;

  {      . "Separator" -     }
  function GetListTasks (NumberSection: Integer; Separator: String): String; overload;

  {       }
  function GetNameSectionUnderNumber (Number: Integer): String;

  {       }
  function GetNumberSectionUnderName (Name: String): Integer;

  {          }
  function GetTaskNameUNumbSect_NumbTask (NumbSection, NumbTask: Integer): String;


implementation

uses Windows, SysUtils, Classes, ComObj, Variants;

function CreatexStart: Boolean;
begin
  try
    xStarter:=CreateOleObject('xStarter.Automation');
    Result:=True;
  except
    on E: Exception do
      begin
        Result:=False;
        raise;
      end;
  end;
end;

procedure UnassignedxStart;
begin
  xStarter:=Unassigned;
end;

function GetSectionsCount: Integer;
begin
  Result:=xStarter.SectionsCount;
end;

function GetTasksCount(Section: Integer): Integer;
begin
  xStarter.SectionNumber:=Section;
  Result:=xStarter.TasksCount;
end;

function RunTask (SectionNumber, TaskNumber: Integer): Boolean;
begin
  try
    xStarter.SectionNumber:=SectionNumber;
    xStarter.TaskNumber:=TaskNumber;
    xStarter.RunTask;
    Result:= True;
  except
    Result:= false;
  end;
end;

function RunTask (SectionName, TaskName: String): Boolean;
var SectionsCount, TasksCount, I, J: Integer;

    NumbSection: Integer;
    NumbTask: Integer;
begin
  Result:=false;

  if (SectionName = '') or (TaskName = '' ) then
    Exit;

  NumbSection:=-1;
  NumbTask:=-1;

  try
    SectionsCount:=xStarter.SectionsCount - 1;

    for I := 0 to SectionsCount do
      begin
        xStarter.SectionNumber:=I;
        if SectionName = xStarter.SectionName then
          begin
            NumbSection:=I;
            xStarter.SectionNumber:=I;
            TasksCount:=xStarter.TasksCount-1;
            for J := 0 to TasksCount do
              begin
                xStarter.TaskNumber:=J;
                if TaskName = xStarter.TaskName then
                  begin
                    NumbTask:=J;
                    Break;
                  end;
              end;
            Break;
          end;
      end;

    if (NumbSection = -1) or (NumbTask = -1) then
        Exit;

    xStarter.SectionNumber:=NumbSection;
    xStarter.TaskNumber:=NumbTask;
    xStarter.RunTask;
    Result:=true;
  except
    Result:=false;
  end;

end;

function GetListSection (Separator: String): String;
var SectionsCount, I: Integer;
    List: String;
begin
  SectionsCount:=xStarter.SectionsCount - 1;

  if Separator = '' then
    Separator:=#13#10;

  for I := 0 to SectionsCount do
    begin
      xStarter.SectionNumber:=I;
      if I <> SectionsCount then
        List:=List+(xStarter.SectionName+Separator)
      else
        List:=List+xStarter.SectionName;
    end;
  Result:=List;
end;

function GetListTasks (NameSection, Separator: String): String;
var SectionsCount, TasksCount, I, J: Integer;
    List: String;
begin
  if NameSection = '' then
    Exit;

  SectionsCount:=xStarter.SectionsCount - 1;

  if Separator = '' then
    Separator:=#13#10;

  for I := 0 to SectionsCount do
    begin
      xStarter.SectionNumber:=I;
      if NameSection = xStarter.SectionName then
        begin
          xStarter.SectionNumber:=I;
          TasksCount:=xStarter.TasksCount-1;
          for J := 0 to TasksCount do
            begin
              xStarter.TaskNumber:=J;
              if J <> TasksCount then
                List:=List+(xStarter.TaskName+Separator)
              else
                List:=List+xStarter.TaskName;
            end;
          break;
        end else List:='Name is not found';
    end;
  Result:=List;
end;

function GetListTasks (NumberSection: Integer; Separator: String): String;
var SectionsCount, TasksCount, J: Integer;
    List: String;
begin
  SectionsCount:=xStarter.SectionsCount - 1;

  if (NumberSection > SectionsCount) or (NumberSection < 0 ) then
    begin
      Result:='';
      Exit;
    end;

  if Separator = '' then
    Separator:=#13#10;

  xStarter.SectionNumber:=NumberSection;
  TasksCount:=xStarter.TasksCount-1;
  for J := 0 to TasksCount do
    begin
      xStarter.TaskNumber:=J;
      if J <> TasksCount then
        List:=List+(xStarter.TaskName+Separator)
      else
        List:=List+xStarter.TaskName;
    end;
  Result:=List;
end;

function GetNameSectionUnderNumber (Number: Integer): String;
var SectionsCount: Integer;
begin
  SectionsCount:=xStarter.SectionsCount - 1;

  Result:='';

  if (Number < 0) or (Number > SectionsCount) then
      Exit;

  xStarter.SectionNumber:=Number;
  Result:=xStarter.SectionName;
end;

function GetNumberSectionUnderName (Name: String): Integer;
var SectionsCount, I: Integer;
begin
  Result:=-1;

  if Name = '' then
    Exit;

  SectionsCount:=xStarter.SectionsCount - 1;
  for I := 0 to SectionsCount do
    begin
      xStarter.SectionNumber:=I;
      if Name = xStarter.SectionName then
        begin
          Result:=I;
          Break;
        end;
    end;
end;

function GetTaskNameUNumbSect_NumbTask (NumbSection, NumbTask: Integer): String;
var SectionsCount, TasksCount: Integer;
begin
  Result:='';

  SectionsCount:=xStarter.SectionsCount - 1;
  if (NumbSection < 0) or (NumbSection > SectionsCount) then
    Exit;

  xStarter.SectionNumber:=NumbSection;

  TasksCount:=xStarter.TasksCount-1;
  if (NumbTask < 0) or (NumbTask > TasksCount) then
    Exit;

  xStarter.TaskNumber:=NumbTask;
  Result:=xStarter.TaskName;

end;

end.
